| dbxreport

## Wiki

The master copies of EMBOSS documentation are available at http://emboss.open-bio.org/wiki/Appdocs on the EMBOSS Wiki.

Please help by correcting and extending the Wiki pages.

## Function

Validate index and report internals for dbx databases

## Description

dbxreport reports statistics for the index fields of a database.

## Algorithm

The index directory is, by default, the index directory af an installed database.

dbxreport reads the index file, reporting on the file name, the number of index terms, the depth of the index tree, statistics of internal page types and the free space in an uncompressed index.

## Usage

Here is a sample session with dbxreport

    % dbxreport -indexdir .
    Validate index and report internals for dbx databases
    EMBOSS database name: embl
    Index fields [id]: id,acc
    Output file [embl.dbxreport]:

Go to the output files for this example

## Command line arguments

    Validate index and report internals for dbx databases
    Version: EMBOSS:6.6.0.0

       Standard (Mandatory) qualifiers:
      [-dbname]            string     EMBOSS database name (Any string from 2 to
                                      19 characters, matching regular expression
                                      /[A-z][A-z0-9_]+/)
      [-fields]            string     [id] A list of index fields separated by
                                      spaces or commas. (Any string)
       -outfile            outfile    [*.dbxreport] Output file name

       Additional (Optional) qualifiers: (none)
       Advanced (Unprompted) qualifiers:
       -indexdir           directory  Index directory (optional)
       -fullreport         boolean    [N] Write full details to debug file

       Associated qualifiers:

       "-indexdir" associated qualifiers
       -extension          string     Default file extension

       "-outfile" associated qualifiers
       -odirectory         string     Output directory

       General qualifiers:
       -auto               boolean    Turn off prompts
       -stdout             boolean    Write first file to standard output
       -filter             boolean    Read first file from standard input, write
                                      first file to standard output
       -options            boolean    Prompt for standard and additional values
       -debug              boolean    Write debug output to program.dbg
       -verbose            boolean    Report some/full command line options
       -help               boolean    Report command line options and exit. More
                                      information on associated and general
                                      qualifiers can be found with -help -verbose
       -warning            boolean    Report warnings
       -error              boolean    Report errors
       -fatal              boolean    Report fatal errors
       -die                boolean    Report dying program messages
       -version            boolean    Report version number and exit

Qualifier | Type | Description | Allowed values | Default
--- | --- | --- | --- | ---
Standard (Mandatory) qualifiers
[-dbname] (Parameter 1) | string | EMBOSS database name | Any string from 2 to 19 characters, matching regular expression /[A-z][A-z0-9_]+/ | Required
[-fields] (Parameter 2) | string | A list of index fields separated by spaces or commas. | Any string | id
-outfile | outfile | Output file name | Output file | <*>.dbxreport
Additional (Optional) qualifiers
(none)
Advanced (Unprompted) qualifiers
-indexdir | directory | Index directory (optional) | Directory |
-fullreport | boolean | Write full details to debug file | Boolean value Yes/No | No
Associated qualifiers
"-indexdir" associated directory qualifiers
-extension | string | Default file extension | Any string |
"-outfile" associated outfile qualifiers
-odirectory | string | Output directory | Any string |
General qualifiers
-auto | boolean | Turn off prompts | Boolean value Yes/No | N
-stdout | boolean | Write first file to standard output | Boolean value Yes/No | N
-filter | boolean | Read first file from standard input, write first file to standard output | Boolean value Yes/No | N
-options | boolean | Prompt for standard and additional values | Boolean value Yes/No | N
-debug | boolean | Write debug output to program.dbg | Boolean value Yes/No | N
-verbose | boolean | Report some/full command line options | Boolean value Yes/No | Y
-help | boolean | Report command line options and exit. More information on associated and general qualifiers can be found with -help -verbose | Boolean value Yes/No | N
-warning | boolean | Report warnings | Boolean value Yes/No | Y
-error | boolean | Report errors | Boolean value Yes/No | Y
-fatal | boolean | Report fatal errors | Boolean value Yes/No | Y
-die | boolean | Report dying program messages | Boolean value Yes/No | Y
-version | boolean | Report version number and exit | Boolean value Yes/No | N

## Input file format

dbxreport reads index files created by any of the EMBOSS 'dbx' indexing applications.

## Output file format

The output is a text report of index statistics.

### Output files for usage example

### File: embl.dbxreport

    Index 'id' (.xid)
      compressed:  Yes (Compressed)
       cachesize: 20000 (Size of primary cache)
    seccachesize: 20000 (Size of secondary cache)
        pagesize: 2048 (Page size)
     secpagesize:  512 (Secondary page size)
       pagecount:    3 (Primary page count)
       pagecount:    0 (Secondary page count)
        refcount:    0 (Number of reference files)
           order:   71 (Tree order)
          sorder:   22 (Order of secondary tree)
           level:    0 (Level of tree)
          slevel:    0 (Level of secondary tree)
            fill:   56 (Entries per bucket)
           sfill:   41 (Entries per secondary bucket)
        keylimit:   15 (Max key size)
         idlimit:    0 (Max secondary id size)
           count:    6 (Unique entries in index)
       fullcount:    6 (Total entries in index)
    Identifier index 'id' index found with 3 pages
          COUNT: 6
       COUNTALL: 6
           root: 1
         bucket: 2
    ...       keys: 1
    ...      bkeys: 6
    ...   total_size: 6144
    ...    freespace: 5871, 95.6% of uncompressed 6144
          FOUND: 6
       FOUNDALL: 6
    Index 'acc' (.xac)
      compressed:  Yes (Compressed)
       cachesize: 20000 (Size of primary cache)
    seccachesize: 20000 (Size of secondary cache)
        pagesize: 2048 (Page size)
     secpagesize:  512 (Secondary page size)
       pagecount:    3 (Primary page count)
       pagecount:    3 (Secondary page count)
        refcount:    0 (Number of reference files)
           order:   71 (Tree order)
          sorder:   22 (Order of secondary tree)
           level:    0 (Level of tree)
          slevel:    0 (Level of secondary tree)
            fill:   56 (Entries per bucket)
           sfill:   41 (Entries per secondary bucket)
        keylimit:   15 (Max key size)
         idlimit:    0 (Max secondary id size)
           count:    7 (Unique entries in index)
       fullcount:    9 (Total entries in index)
    Identifier index 'acc' index found with 6 pages
          COUNT: 7
       COUNTALL: 9
           root: 1
        numroot: 1
         bucket: 2
      numbucket: 2
    ...       keys: 2
    ...      bkeys: 7
    ...      bdups: 1
    ...      bxtra: 2
    ...      nkeys: 3 (0)
    ...   total_size: 7680
    ...    freespace: 7236, 94.2% of uncompressed 7680
          FOUND: 7
       FOUNDALL: 9

## Data files

None.

## Notes

None.

## References

None.

## Warnings

None.

## Diagnostic Error Messages

None.

## Exit status

It always exits with status 0.

## Known bugs

None.

## See also

Program name | Description
--- | ---
dbiblast | Index a BLAST database
dbifasta | Index a fasta file database
dbiflat | Index a flat file database
dbigcg | Index a GCG formatted database
dbxcompress | Compress an uncompressed dbx index
dbxedam | Index the EDAM ontology using b+tree indices
dbxfasta | Index a fasta file database using b+tree indices
dbxflat | Index a flat file database using b+tree indices
dbxgcg | Index a GCG formatted database using b+tree indices
dbxobo | Index an obo ontology using b+tree indices
dbxresource | Index a data resource catalogue using b+tree indices
dbxstat | Dump statistics for dbx databases
dbxtax | Index NCBI taxonomy using b+tree indices
dbxuncompress | Uncompress a compressed dbx index

## Author(s)

Peter Rice
European Bioinformatics Institute, Wellcome Trust Genome Campus, Hinxton, Cambridge CB10 1SD, UK

Please report all bugs to the EMBOSS bug team (emboss-bug © emboss.open-bio.org) not to the original author.

## History

## Target users

This program is intended to be used by everyone and everything, from naive users to embedded scripts.

## Comments

None